﻿using FarPoint.Win.Spread;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SpreadRowDragging
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            fpSpread1.AllowRowMove = true;
            fpSpread1.RowDragMove += FpSpread1_RowDragMove;
            fpSpread1.RowDragMoveCompleted += FpSpread1_RowDragMoveCompleted;
            fpSpread1.MouseMove += FpSpread1_MouseMove;
        }
        private bool _rowMoving;

        private void FpSpread1_MouseMove(object sender, MouseEventArgs e)
        {
            if (_rowMoving)
            {
                //code to execute during moving row
                var ht = fpSpread1.HitTest(e.Location.X,e.Location.Y);
                var row = -1;
                if (ht != null)
                {
                    if(ht.Type == HitTestType.RowHeader)
                        row = ht.HeaderInfo.Row;
                    else if(ht.Type == HitTestType.Viewport)
                        row = ht.ViewportInfo.Row;
                    Debug.WriteLine("CurrentRow: " + row);
                }
                
            }
        }

        private void FpSpread1_RowDragMoveCompleted(object sender, DragMoveCompletedEventArgs e)
        {
            _rowMoving = false;
        }

        private void FpSpread1_RowDragMove(object sender, DragMoveEventArgs e)
        {
            _rowMoving = true;
        }
    }
}
